unit specialform;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TFun_Ball = class(TForm)
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    // hwndOld: THandle;
  public
    procedure Hit (var Msg: TMessage);
      message wm_ncHitTest;
  end;

var
  Fun_Ball: TFun_Ball;

implementation

{$R *.DFM}

procedure TFun_Ball.FormCreate(Sender: TObject);
var
  hregion: THandle;
begin
  hregion := CreateEllipticRgn (1, 1, 50, 50);
  SetWindowRgn (Handle, hregion, true);
end;

procedure TFun_Ball.FormPaint(Sender: TObject);
begin
//  Canvas.Pen.Width := 3;
//  Canvas.Pen.Color := clBlack;
//  Canvas.Ellipse (1, 1, 49, 49);
{  Canvas.Ellipse (10, 10, 20, 40);
  Canvas.Ellipse (30, 10, 40, 40);
  Canvas.Pen.Color := clBlue;
  Canvas.Ellipse (13, 33, 17, 37);
  Canvas.Ellipse (33, 33, 37, 37);
}end;

procedure TFun_Ball.Hit(var Msg: TMessage);
begin
  Msg.Result := htCaption;
end;

procedure TFun_Ball.Timer1Timer(Sender: TObject);
var
{  hwnd: THandle;
  rc: tRect;}
  pt: TPoint;
  dx, dy: Integer;
begin
  GetCursorPos (pt);
  dx := (pt.x - Left - 25) div 6;
  dy := (pt.y - Top - 25) div 7;

  SetBounds (Left + dx, Top + dy, 50, 50);
{
  hwnd := WindowFromPoint (Point (
    Left + Width div 2, Top + 51));
//  if hwnd <> hwndOld then
//    Beep;
  GetWindowRect (hwnd, rc);
  if rc.Top < Top + 51 then
    Top := Top + 2
  else
    Top := Top - 2;
  hwndOld := hwnd;
}
  if dx * dy > 3 then
    Color := Random (1000000);
end;

end.
