unit sock2kform;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ScktComp;

type
  TForm3 = class(TForm)
    ListBox1: TListBox;
    Edit1: TEdit;
    ButtonSend: TButton;
    ClientSocket1: TClientSocket;
    ServerSocket1: TServerSocket;
    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ButtonSendClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    procedure Later (var Msg: TMessage); message wm_user;
  end;

var
  Form3: TForm3;

implementation

{$R *.DFM}

procedure TForm3.ServerSocket1ClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  str: string;
begin
  str := Socket.ReceiveText;
  ListBox1.itemIndex :=
    ListBox1.Items.Add (str);

  // forward text
  if clientsocket1.Active then
    clientSocket1.Socket.SendText (Caption + ' ' + str);

  // close?
  if pos ('close', str) > 0 then
    Release;
end;

procedure TForm3.ButtonSendClick(Sender: TObject);
begin
  if ClientSocket1.Active then
    ClientSocket1.Socket.SendText (Caption + ' - ' + Edit1.Text);
end;

procedure TForm3.FormCreate(Sender: TObject);
var
  par: integer;
begin
  par := StrToIntDef (ParamStr (1), 0);
  Caption := 'Tier ' + IntToStr (par);
  //activate server on a port
  ServerSocket1.Port := 10000 + par;
  ServerSocket1.Active := True;
  ClientSocket1.Port := ServerSocket1.Port - 1;
  // activate clients but the last one, later
  PostMessage (Handle, wm_user, 0, 0); // call Later later

  if par > 0 then
  begin
    // start another one
    WinExec (pChar (Application.ExeName +
      ' ' + IntToStr (par - 1)), sw_Show);
  end
  else
  begin
    Edit1.Enabled := False;
    ButtonSend.Enabled := False;
  end;
end;

procedure TForm3.Later(var Msg: TMessage);
begin
  if ClientSocket1.port >= 10000 then
    ClientSocket1.active := True;
  // debug code
{  Caption := Caption + Format (' - serv %d, cli %d %d',
    [ServerSocket1.port, ClientSocket1.Port,
    Integer (ClientSocket1.Active)]);
}end;

end.
