unit dform2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Button1: TButton;
    Label2: TLabel;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses math;

function CurrentYear: Integer;
var
  y, m, d: Word;
begin
  DecodeDate (Now, y, m, d);
  Result := y;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  d: TDate;
begin
  d := StrToDate (Edit1.Text);
  Label2.Caption := 'You MIGHT BE ' + IntToStr (round (now - d) div 365) +
    ' years old or ' + IntToStr (round (d - now) div 365) +
    ' years old, but probably you can compute it by yourself';
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  d: TDate;
  days: Integer;
begin
  d := StrToDate (Edit1.Text);
  Label2.Caption := 'Your birthday is APPROXIMATELY in: ';
  days := 365 - round (now - d) mod 365;
  if (days < 0) or (days > 365) then
    Label2.Caption := Label2.Caption +
      IntToStr (random (365)) + ' days (?!)'
  else
    Label2.Caption := Label2.Caption +
      IntToStr (days) + ' days';
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  d: TDate;
begin
  d := StrToDate (Edit1.Text);
  try
    Label2.Caption := 'My computation returns ' +
      IntToStr (Round (Math.Log2 (now - d))) +
      '. Isn''t it great we are still working?';
  except
  on e: Exception do
    Label2.Caption := 'My computation returns an error, ' +
      'the program is perfect, its "year 2000" fault';
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  d: TDate;
  nPeriods: Integer;
begin
  d := StrToDate (Edit1.Text);
  d := d + 60*365; // you at 60
  nPeriods := round (d - now) div 365;
  Label2.Caption := 'MY GUESS about your total money at 60: ' +
    IntToStr (round (FutureValue(
      0.035, // interest rate
      nPeriods, // nperiods: years diff.
      -1000, // payment
      0, // present
      TPaymentTime(1)))) // paytime
      + '$. If this seems too much or too little, ' +
      ' you are either very poor or very rich, unless it''s year 2000.';
end;

end.
